"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.pickRandom = exports.shuffle = exports.mapRange = exports.noise3D = void 0;
var simplex_noise_1 = __importDefault(require("simplex-noise"));
var noiseGenerator = new simplex_noise_1.default();
exports.noise3D = function (x, y, z) {
    return noiseGenerator.noise3D(x, y, z);
};
exports.mapRange = function (value, inputMin, inputMax, outputMin, outputMax) {
    if (Math.abs(inputMin - inputMax) < Number.EPSILON)
        return outputMin;
    var outVal = ((value - inputMin) / (inputMax - inputMin)) * (outputMax - outputMin) +
        outputMin;
    if (outputMax < outputMin) {
        if (outVal < outputMax) {
            outVal = outputMax;
        }
        else if (outVal > outputMin) {
            outVal = outputMin;
        }
    }
    else if (outVal > outputMax) {
        outVal = outputMax;
    }
    else if (outVal < outputMin) {
        outVal = outputMin;
    }
    return outVal;
};
exports.shuffle = function (array) {
    var _a;
    var a = __spreadArrays(array);
    for (var i = a.length - 1; i > 0; i--) {
        var j = Math.floor(Math.random() * (i + 1));
        _a = [a[j], a[i]], a[i] = _a[0], a[j] = _a[1];
    }
    return a;
};
exports.pickRandom = function (array) {
    return array[Math.floor(Math.random() * array.length)];
};
